%% Restart and Init
clear all; 
clc;

file.name = 'lifan2'; 
file.csv = [file.name, '.csv'];     % Geometry Points and ASM Points
file.cnt = [file.name, '.cnt'];     % CNT file including error rate and EOG data
file.et = [file.name, '_et'];       % Error rate
file.cv = [file.name, '_cv'];       % Data for Geometry Points and ASM Points
file.eog = [file.name, '_eog'];     % Data for EOG
file.eog2 = [file.name, '_eog2'];     % Data for EOG (higher sample rate)
file.feog = [file.name, '_feog'];     % EOG Features
file.fvideo = [file.name, '_fvideo'];   % Video Features

para.init.totalTime = 60 * 67;
para.init.a = 4000; 
para.init.b = 30000;
para.init.c = 50001;

para.final.a = 38;
para.final.b = 0;
para.final.c = 5;

para.eog.feature_number = 48;
para.eog.source_mode = 1; 
para.eog.sample_rate = 125; %125;
para.eog.time_param.period = 8; 
para.eog.time_param.start_time = 100;
para.eog.time_param.number = 400;

para.svm.s = 3; 
para.svm.t = 2; 
para.svm.c = 2^3; 
para.svm.g = 2^(-6);
para.svm.p = 2^(-10);
para.svm.all = ['-s ', num2str(para.svm.s),' -t ', num2str(para.svm.t), ' -c ', num2str(para.svm.c) ,' -g ', num2str(para.svm.g), ' -p ', num2str(para.svm.p) ];

para.offset = 42; 
para.asm.fps = 38;
para.asm.low = 0; 
para.asm.bthred = 5; 
para.asm.cthred = 4;
para.asm.mthred = 2;
para.asm.blinkthred = 1.7;
para.asm.closethred = 0.3;
para.asm.openthred = 0.7;
para.asm.closedthred = 0.2;
para.asm.openedthred = 0.8;
para.asm.semthred = 0.5;
para.asm.remthred = 0.1;
para.asm.energythred = 0.9;
para.asm.openedthred = 0.8;

para.asm.windowsize = 8 * para.asm.fps;
