%% Read data - Error Rate
cnt = loadcnt(file.cnt);
[at et] = ResStat(cnt.event, para.init.a, para.init.b, para.init.c);
save(file.et, 'et');

%% Read data - Vision Data
data = load(file.csv);
save(file.cv, 'data');

%% Read data - EOG CNT
clear all; 
clc;
init;
cnt = loadcnt_reSampling(1, file.cnt);
save(file.eog, 'cnt');

%% Extract EOG features
load(file.eog);
source = eog(cnt.data, para.eog.sample_rate, para.eog.source_mode);
feature_eog.blink = blink(source, para.eog.sample_rate, para.eog.time_param);
feature_eog.em = em(source, para.eog.sample_rate, para.eog.time_param);
feature_eog.total = [feature_eog.blink; feature_eog.em];   
feature_eog.n = size(feature_eog.total, 2);
save(file.feog, 'feature_eog');

%% Plot EOG features
load(file.feog);
hold on;
for i = 1 : feature_eog.n
    plot(feature_eog.total(i));
end
hold off;

%% Read from before
load(file.eog2); 
feature_eog.blink = feature; 


%% bug

feature = feature_asm.total;
 mask1 = [1:100 201:300];
v1 = label(mask1);
f1 = feature(:, mask1);
v2 = label;
f2 = feature;
model = svmtrain(v1.', f1.', para.svm.all);
[result, accuracy, values] = svmpredict(v2.', f2.', model);
aa = 80; 
bb = 0; 
cc = 10;
%result = eegfilt(result', aa, bb, cc);
%result = offset(result, 25);
plot(label, 'r');
hold on;
plot(result(st:end), 'b');


%% FINAL TEST
init;
load(file.et);
load(file.feog); 
% load(file.eog2); 
load(file.fvideo);
start = 7236 / 500 / (67 * 3600) * size(et,2);  % ý    0.05982
label = downsize(et, feature_eog.n); 

mask1 = [50:75 100:125 151:200 251:300 351:375]; mask2 = [25:100 101:150 201:250 301:350];
mask1 = [1:70 111:180 200:350 370:400];
mask1 = [1:70 111:180 221:290 331:400];

feature = feature_eog.total;
v1 = label(mask1);
f1 = feature(:, mask1);
l = 1; 
r = 400; 
v2 = label;
f2 = feature;

model = svmtrain(v1.', f1.', para.svm.all);
[result, accuracy, values] = svmpredict(v2.', f2.', model);

coef(1:size(feature_eog.total,1)) = 0; 
for k = 1 : size(feature_eog.total,1)
    c = corrcoef(label, feature_eog.total(k,:));
    coef(k) = c(2);
end


n = size(label,2);
st = 1; 
vv = downsize(et, feature_eog.n); 
plot(vv(st:end), 'G');
hold on;
% plot(result(st:end), 'B');
aa = 80; 
bb = 0; 
cc = 10;
% EOGpredict = eegfilt(EOGpredict, aa, bb, cc);
% plot(EOGpredict(st:end), 'm');
plot(result(st:end), 'm');
corrcoef(label, result)
% for j  = 1 : length(feature(1,:))
%     c = corrcoef(label, feature(j,:));
%     coef.eog(j) = c(2);
% end
% coef.eogr = corrcoef(label, EOGpredict);


para.svm.all = ['-s ', num2str(para.svm.s),' -t ', num2str(para.svm.t), ' -c ', num2str(para.svm.c) ,' -g ', num2str(para.svm.g), ' -p ', num2str(para.svm.p) ];
feature = feature_asm.total;
mask1 = [1:100 201:300];
v1 = label(mask1);
f1 = feature(:, mask1);
v2 = label;
f2 = feature;
model = svmtrain(v1.', f1.', para.svm.all);
[result, accuracy, values] = svmpredict(v2.', f2.', model);
aa = 80; 
bb = 0; 
cc = 10;
%result = eegfilt(result', aa, bb, cc);
%result = offset(result, 25);
result = normalize(result);
plot(result(st:end), 'b');
corrcoef(label, result)
% for j  = 1 : length(feature(1,:))
%     c = corrcoef(label, feature(j,:));
%     coef.asm(j) = c(2);
% end
% coef.asmr = corrcoef(label(300:400), result(300:400));
 
% res2 =
% 
%     -1
%      6
%     -6
% 
% res1
% 
% res1 =
% 
%     10
%     -6
%     -2
mask1 = [1:70 111:180 221:290 331:400];

para.svm.c = 2^3; 
para.svm.g = 2^(-6);
para.svm.p = 2^(-10);
para.svm.all = ['-s ', num2str(para.svm.s),' -t ', num2str(para.svm.t), ' -c ', num2str(para.svm.c) ,' -g ', num2str(para.svm.g), ' -p ', num2str(para.svm.p) ];

feature = [feature_asm.total; feature_eog.total];
% feature = [EOGpredict; result'; feature_asm.eye;];
% feature = [feature_eog.total];

% for j  = 1 : length(feature(1,:))
%     c = corrcoef(label, feature(j,:));
%     coef.all(j) = c(2);
% end
% coef.allr = corrcoef(label(300:400), result(300:400));


v1 = label(mask1);
f1 = feature(:, mask1);
v2 = label;
f2 = feature;
model = svmtrain(v1.', f1.', para.svm.all);

aa = 80; 
bb = 0; 
cc = 10;
% result2 = eegfilt(result2, aa, bb, cc);
[result2, accuracy, values] = svmpredict(v2.', f2.', model);
plot(result2(st:end), 'r');

td(1,:,1) = result;
td(1,:,2) = result2;
% result3 = fuzzy(td, label); 
% plot(result3(st:end), 'K');

legend('Error rate', 'Predicted value based on EOG', 'Predicted value based on video', 'Predicted value by combination', 'Predicted value by fuzzy integral'); % 'Predicted value by fuzzy integral'
xlabel('sequence');
ylabel('value');
axis([1, 400, 0, 1]);

%% SVM TEST
init;
load(file.et);
load(file.feog); 
load(file.fvideo);

feature = feature_asm.total;
feature = [feature_asm.total; feature_eog.total];
label = downsize(et, feature_eog.n); 

mask1 = [1:70 111:180 221:290 331:400];
mask2 = [71:110 181:220 291:330];
mask1 = [1:100 201:300];
v1 = label(mask1);
v2 = label;
f1 = feature(:,mask1);
f2 = feature;

mse = 10000; 
scc = 0; 
for a = -10 : 10
for b = -10 : 10
clc;
   
for c = -10 : 10
str = sprintf('-s 3 -t 2 -c %f -g %f -p %f', 2^a, 2^b, 2^c);
model = svmtrain(v1.', f1.', str);
[result, accuracy, values] = svmpredict(v2.', f2.', model);
p1((a+10) * 441+(b+10) * 21+(c+10) + 1) = accuracy(2);
p2((a+10) * 441+(b+10) * 21+(c+10) + 1) = accuracy(3);
if accuracy(2) < mse
    mse = accuracy(2);
    res1 = [a;b;c];
end 
if accuracy(3) > scc
    scc = accuracy(3);
    res2 = [a;b;c];
end
    
end
end
end
%%
a = res2(1); b = res2(2); c = res2(3);
mask1 = [1:70 111:180 221:290 331:400];
mask2 = [71:110 181:220 291:330];
v1 = label(mask1);
f1 = feature(:,mask1);
v2 = label(mask2);
f2 = feature(:,mask2);

str = sprintf('-s 3 -t 2 -c %f -g %f -p %f', 2^a, 2^b, 2^c);
model = svmtrain(v1.', f1.', str);
[result, accuracy, values] = svmpredict(v2.', f2.', model);
plot(v2, 'b');
hold on;
plot(result, 'r');


% a1 = 0; 
% res1 = 0; 
% a2 = 0; 
% res2 = 0; 
% for i = 1 : 21 * 21 * 21
%     if p1(i) > a1
%         a1 = p1(i);
%         res1 = i;
%     end
%     if p2(i) > a2
%         a2 = p2(i);
%         res2 = i;
%     end
% end
